Subject: bug#12911: 24.3.50; let users decide where (& perhaps whether)`emacs_backtrace.txt' files are written

From: Eli Zaretskii <[email-masked]>
Date: Tue, 20 Nov 2012 21:58:35 +0200

> X-Spam-Status: No, score=-4.6 required=5.0 tests=BAYES_00,RCVD_IN_DNSWL_MED,
> 	RP_MATCHES_RCVD,UNPARSEABLE_RELAY autolearn=ham version=3.3.2
> From: "Drew Adams" <[email-masked]>
> Cc: <[email-masked]>
> Date: Tue, 20 Nov 2012 10:57:00 -0800
> 
> > Yet another candidate is "My Documents" (e.g., bzr uses
> > it).  But none of them is really for the user, according to Windows
> > guidelines.
> 
> Really?  I don't know (or care too much) what Windows guidelines might say about
> this.  But I would be mildly curious about that, if you happen to have a URL.

  http://msdn.microsoft.com/en-us/library/windows/desktop/bb762494%28v=vs.85%29.aspx

> Everyone I know considers `My Documents' and its subfolders to be a user folder
> - maybe even *THE* user folder par excellence.

"The file system directory used to physically store a user's common
repository of documents."  What do you make of that?  "User's
documents", not "user's files".

> There is even a `My Documents' folder for each user defined for the machine.
> (Another name for it can be Administrator's Documents, Drew's Documents, Eli's
> Documents. etc.)

Yes, that's the "virtual folder" part in the description on the above
URL.  But then you also have per-user "Application Data", "Temporary
Internet Files", "Favorites", and many more.  Being per user does not
mean it's up for grabs for any particular purpose.

> Why any program (e.g. bzr, apparently) would want to consider that folder as
> fair game for stuffing its internal stuff is beyond me.  How impolite.

Not at all.  It is customary, at least on Unix, to put logs, command
history, and other similar files in the user's home directory.

> Anyway, let's see what good ol' Wikipedia has to say...
> http://en.wikipedia.org/wiki/My_Documents
> 
>  My Documents is the name of a special folder on the computer's
>  hard drive that the system commonly uses to store a user's
>  documents, music, pictures, downloads, and other files.
> 
> Whaddya know?  And it says `My Documents' was introduced, "as a standard
> location for storing user-created files."

Don't believe everything Wikipedia says.

> Hm.  That all sounds just like what I think about it.  And about its subfolders,
> including `My Music',...  That "My" should tell us something, I would think.

Then why did that "My" part disappear in latest Windows versions?
There's no C:\Users\<username>\Documents etc., with "My Documents"
just a symlink.  See

  http://windows.microsoft.com/is-IS/windows-vista/What-happened-to-My-Documents

> `My Documents' is not the kind of place a civilized program would want to
> pollute with its own crap.

It's _your_ crap, because it's _you_ who runs that program.

> That is not the same as a place to stuff program-internal data.  We have
> `Program Files' and user-specific `Local Settings\Application Data' for that
> kind of thing.

As I wrote earlier, writing to "Program Files" is a bad idea, as it is
not writable in Vista and later.